module 0-Logic where 

-- In this practical we play around with Curry-Howard
-- isomorphism in Agda.

variable
  P Q R : Set
  A B C : Set

-- Implication is encoded by function space.

I : P → P
I = {!   !} 

K : P → (Q → P)
K = {!   !}

S : (P → Q → R) → (P → Q) → P → R
S = {!   !}


flip : (P → Q → R) → Q → P → R
flip = {!   !} 

prac7_1d : P → (P → Q) → (P → Q → R) → R
prac7_1d = {!   !}

-- True is encoded by the type ⊤, a type with exactly
-- one component tt.

data ⊤ : Set where
  tt : ⊤

-- False is represented by ⊥, a type having no terms.

data ⊥ : Set where

-- Negation of P is P → False.

¬ : Set → Set
¬ P = P → ⊥

-- Conjunction P ∧ Q is encoded by a pair P × Q.

data _∧_ (A B : Set) : Set where
  _,_ : A → B → A ∧ B

infixr 4 _,_
infixr 2 _∧_

fst : A ∧ B → A
fst (x , y) = x

snd : A ∧ B → B
snd (x , y) = y

-- Disjunction P ∨ Q is encoded by the sum type.

data _∨_ (A B : Set) : Set where
  inl : A → A ∨ B
  inr : B → A ∨ B

infixr 1 _∨_

-- Exercises from your Logic class!

uncurry : (P → Q → R) → (P ∧ Q) → R
uncurry = {!   !}

∨-comm : (P ∨ Q) → (Q ∨ P)
∨-comm = {!   !}

  -- ∨ "\ v e e"      "\ o r"
  -- ∧ "\ w e d g e"  "\ a n d"

∧-comm : (P ∧ Q) → (Q ∧ P)
∧-comm = {!   !}

→-∨-weakening-r : (A → B) → (A → (B ∨ C))
→-∨-weakening-r = {!   !}

→-∨-weakening-l : ((A ∨ C) → B) → (A → B)
→-∨-weakening-l = {!   !}

→-∧-weakening-r1 : (A → (B ∧ C)) → (A → B)
→-∧-weakening-r1 = {!   !}

→-∧-weakening-r2 : (A → (B ∧ C)) → (A → C)
→-∧-weakening-r2 = {!   !}

→-∧-distr : (A → (B ∧ C)) → ((A → B) ∧ (A → C))
→-∧-distr = {!   !}

⊥-elim : ⊥ → A
⊥-elim ()

resol : ((A ∨ B) ∧ ¬ B) → A
resol = {!   !}

prac7_1f : (P ∧ Q) → ((P ∨ Q) → R) → R
prac7_1f = {!   !}

¬¬ex-middle : ¬ (¬ (A ∨ ¬ A))
¬¬ex-middle f = f (inr (λ a → f (inl a)))

{- However, we cannot prove that:

ex-middle : A ∨ (¬ A)
ex-middle = ?
-}

A→¬¬A : A → ¬ (¬ A)
A→¬¬A = {!   !}


{- However, we cannot prove that:

¬¬A→A : ¬ (¬ A) → A
¬¬A→A = ?
-}

demorgan : (¬ A ∨ ¬ B) → ¬ (A ∧ B)
demorgan = {!   !}

{- However, we cannot prove that

demorgan' : ¬ (A ∧ B) → (¬ A ∨ ¬ B)
demorgan' = ?

-}

contra : (A → B) → (¬ B → ¬ A)
contra = {!   !}

{- However, we cannot prove that

contra' : (¬ B → ¬ A) → (A → B)
contra' = ?
-}


absorb : (A ∧ (¬ A ∨ B)) → (A ∧ B)
absorb = {!   !}

∨-∧-distr : (A ∨ (B ∧ C)) → (A ∨ B) ∧ (A ∨ C)
∨-∧-distr = {!   !}
